6 # Build LLVM the "Apple way".
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
28 # The fifth parameter is the place where the compiler will be copied once it's
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
65 ################################################################################
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is. Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
80 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/.*\.\([0-9]*\).*/\1/'`
81 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
82 LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
83 RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
84 LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
86 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
87 LLVM_VERSION="$LLVM_SUBMIT_VERSION"
89 LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
92 # Figure out how many make processes to run.
93 SYSCTL=`sysctl -n hw.activecpu`
94 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
95 # Builders can default to 2, since even if they are single processor,
96 # nothing else is running on the machine.
97 if [ -z "$SYSCTL" ]; then
100 JOBS_FLAG="-j $SYSCTL"
102 COMMON_CONFIGURE_OPTS="\
103 --prefix=$DEST_DIR$DEST_ROOT \
104 --enable-assertions=$LLVM_ASSERTIONS \
105 --enable-optimized=$LLVM_OPTIMIZED \
110 UNIVERSAL_SDK_PATH=$SDKROOT \
115 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
116 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
119 # Build the LLVM tree universal.
120 mkdir -p $DIR/obj-llvm || exit 1
121 cd $DIR/obj-llvm || exit 1
123 if [ "$ARM_HOSTED_BUILD" = yes ]; then
124 # The cross-tools' build process expects to find an existing cross toolchain
125 # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
126 rm -rf $DIR/bin || exit 1
127 mkdir $DIR/bin || exit 1
128 for prog in ar nm ranlib strip lipo ld as ; do
129 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
130 T=`xcrun -sdk $SDKROOT -find ${prog}`
131 ln -s $T $DIR/bin/$prog
132 echo '#!/bin/sh' > $P || exit 1
133 echo 'exec '$T' "$@"' >> $P || exit 1
134 chmod a+x $P || exit 1
136 # Set up the links for clang.
137 for prog in clang clang++ ; do
138 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
139 T=`xcrun -sdk $SDKROOT -find ${prog}`
140 ln -s $T $DIR/bin/$prog
141 echo '#!/bin/sh' > $P || exit 1
142 echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
143 chmod a+x $P || exit 1
149 $SRC_DIR/configure $COMMON_CONFIGURE_OPTS \
150 --enable-targets=arm \
151 --host=arm-apple-darwin10 \
152 --target=arm-apple-darwin10 \
153 --build=i686-apple-darwin10 \
154 --program-prefix="" \
157 if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
158 COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
159 DEPLOYMENT_TARGET=-mios-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
162 make $JOBS_FLAG $COMMON_MAKEFLAGS SDKROOT= UNIVERSAL_ARCH="$HOSTS" \
163 CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
164 if [ $? != 0 ] ; then
165 echo "error: LLVM 'make' failed!"
170 # not $ARM_HOSTED_BUILD
172 export CC=`xcrun -find clang`
173 export CXX=`xcrun -find clang++`
175 if [ "$IOS_SIM_BUILD" = yes ]; then
176 # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
177 configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
178 --build=i686-apple-darwin10"
179 if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
180 COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
181 DEPLOYMENT_TARGET=-mios-simulator-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
184 configure_opts="--enable-targets=arm,x86"
185 if [ -n "$MACOSX_DEPLOYMENT_TARGET" ]; then
186 COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
187 DEPLOYMENT_TARGET=-mmacosx-version-min=$MACOSX_DEPLOYMENT_TARGET"
191 if [ $SDKROOT ]; then
192 CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
194 for host in $HOSTS; do :; done
195 CPPFLAGS="$CPPFLAGS -arch $host"
197 $SRC_DIR/configure $COMMON_CONFIGURE_OPTS $configure_opts \
198 --program-prefix="" \
199 CPPFLAGS="$CPPFLAGS" \
202 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" \
203 CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
204 if [ $? != 0 ] ; then
205 echo "error: LLVM 'make' failed!"
210 ################################################################################
211 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
212 # $DEST_DIR, with occasional 'lipo' commands.
214 cd $DEST_DIR || exit 1
216 # Clean out DEST_DIR in case -noclean was passed to buildit.
219 cd $DIR/obj-llvm || exit 1
221 # Install the tree into the destination directory.
222 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" install
223 if ! test $? == 0 ; then
224 echo "error: LLVM 'make install' failed!"
229 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
230 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
233 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
234 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
235 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
237 # Find the right version of strip to use.
239 if [ -n "$SDKROOT" ]; then
240 STRIP=`xcrun -sdk $SDKROOT -find strip`
243 if [ "x$LLVM_DEBUG" != "x1" ]; then
244 # Strip local symbols from llvm libraries.
246 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
248 $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
249 for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
255 cd $DEST_DIR$DEST_ROOT
256 rm -f bin/.dir etc/llvm/.dir lib/.dir
258 # The Hello dylib is an example of how to build a pass.
259 # The BugpointPasses module is only used to test bugpoint.
260 # These unversioned dylibs cause verification failures, so do not install them.
261 # (The wildcards are used to match a "lib" prefix if it is present.)
262 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
263 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
266 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
269 ################################################################################
270 # Create SYM_DIR with information required for debugging.
272 # Figure out how many make processes to run.
273 SYSCTL=`sysctl -n hw.activecpu`
275 # hw.activecpu only available in 10.2.6 and later
276 if [ -z "$SYSCTL" ]; then
277 SYSCTL=`sysctl -n hw.ncpu`
280 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
281 # can default to 2, since even if they are single processor, nothing else is
282 # running on the machine.
283 if [ -z "$SYSCTL" ]; then
287 cd $SYM_DIR || exit 1
289 # Clean out SYM_DIR in case -noclean was passed to buildit.
292 # Generate .dSYM files
293 DSYMUTIL=`xcrun -find dsymutil`
294 find $DEST_DIR -perm -0111 -type f \
295 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
296 -print | xargs -n 1 -P ${SYSCTL} ${DSYMUTIL}
298 # Save .dSYM files and .a archives
299 cd $DEST_DIR || exit 1
300 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
301 | cpio -pdml $SYM_DIR || exit 1
304 mkdir $SYM_DIR/src || exit 1
306 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
307 | cpio -pdml $SYM_DIR/src || exit 1
309 ################################################################################
310 # Remove libLTO.dylib and lto.h. Those are installed by clang.
312 cd $DEST_DIR$DEST_ROOT
313 rm -f lib/libLTO.dylib
314 rm -f lib/libLTO.a lib/libLTO.la
315 find $DEST_DIR$DEST_ROOT -name lto.h -delete
317 ################################################################################
318 # Remove debugging information from DEST_DIR.
322 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
323 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
325 # Strip debugging information from files
327 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
329 find $DEST_DIR -perm -0111 -type f \
330 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
331 -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
333 chgrp -h -R wheel $DEST_DIR
334 chgrp -R wheel $DEST_DIR
336 ################################################################################
337 # Remove the docs directory
339 rm -rf $DEST_DIR$DEST_ROOT/docs
341 ################################################################################